/*******************************************************************************
 * Copyright (c) 2012 Association for Decentralized Information Management in
 * Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.modeling.typicals.rules;

import java.awt.geom.AffineTransform;

import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.diagram.synchronization.graph.DiagramGraphUtil;
import org.simantics.modeling.typicals.ITypicalSynchronizationRule;
import org.simantics.modeling.typicals.TypicalInfo;

/**
 * @author Tuukka Lehtonen
 */
public enum TransformRule implements ITypicalSynchronizationRule {

    INSTANCE;

    public static TransformRule getInstance() {
        return INSTANCE;
    }

    @Override
    public boolean synchronize(WriteGraph graph, Resource template, Resource instance, TypicalInfo info) throws DatabaseException {
        AffineTransform at = DiagramGraphUtil.getAffineTransform(graph, template);
        AffineTransform copyAt = DiagramGraphUtil.getAffineTransform(graph, instance);
        if (!at.equals(copyAt)) {
            info.messageLog.add("\t\t\ttransform");
            DiagramGraphUtil.setTransform(graph, instance, at);
            return true;
        }
        return false;
    }

}
